window.Gleam.initSearch([{"doc":"birl","title":"birl","content":"# birl\n\n[![Package Version](https://img.shields.io/hexpm/v/birl)](https://hex.pm/packages/birl)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/birl/)\n\nDate/Time handling for gleam\n\n## Quick start\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n\n## Installation\n\nIf available on Hex this package can be added to your Gleam project:\n\n```sh\ngleam add birl\n```\n\nand its documentation can be found at &lt;https://hexdocs.pm/birl&gt;.\n","url":"index.html"},{"doc":"birl/duration","title":"Duration","content":"pub type Duration {\n  Duration(Int)\n}\n\nDuration(Int)\n\n\nSynonyms:\nbirl/duration.Duration\nbirl/duration Duration","url":"birl/duration.html#Duration"},{"doc":"birl/duration","title":"Unit","content":"pub type Unit {\n  MicroSecond\n  MilliSecond\n  Second\n  Minute\n  Hour\n  Day\n  Week\n  Month\n  Year\n}\n\nMicroSecond\n\n\nMilliSecond\n\n\nSecond\n\n\nMinute\n\n\nHour\n\n\nDay\n\n\nWeek\n\n\nMonth\n\n\nYear\n\n\nSynonyms:\nbirl/duration.Unit\nbirl/duration Unit","url":"birl/duration.html#Unit"},{"doc":"birl/duration","title":"accurate_decompose","content":"pub fn accurate_decompose(duration: Duration) -&gt; List(\n  #(Int, Unit),\n)\n Use this if you need very long durations where small inaccuracies could lead to large errors\nSynonyms:\nbirl/duration.accurate_decompose\nbirl/duration accurate_decompose","url":"birl/duration.html#accurate_decompose"},{"doc":"birl/duration","title":"accurate_new","content":"pub fn accurate_new(values: List(#(Int, Unit))) -&gt; Duration\n Use this if you need very long durations where small inaccuracies could lead to large errors\nSynonyms:\nbirl/duration.accurate_new\nbirl/duration accurate_new","url":"birl/duration.html#accurate_new"},{"doc":"birl/duration","title":"decompose","content":"pub fn decompose(duration: Duration) -&gt; List(#(Int, Unit))\n Use this if you need short durations where a year just means 365 days and a month just means 30 days\nSynonyms:\nbirl/duration.decompose\nbirl/duration decompose","url":"birl/duration.html#decompose"},{"doc":"birl/duration","title":"new","content":"pub fn new(values: List(#(Int, Unit))) -&gt; Duration\n Use this if you need short durations where a year just means 365 days and a month just means 30 days\nSynonyms:\nbirl/duration.new\nbirl/duration new","url":"birl/duration.html#new"},{"doc":"birl/duration","title":"parse","content":"pub fn parse(expression: String) -&gt; Result(Duration, Nil)\n You can use this function to create a new duration using expressions like:\n\n     &quot;accurate: 1 Year - 2days + 152M -1h + 25 years + 25secs&quot;\n\n where the units are:\n\n     Year:         y, Y, YEAR, years, Years, ...\n\n     Month:        mon, Month, mONths, ...\n\n     Week:         w, W, Week, weeks, ...\n\n     Day:          d, D, day, Days, ...\n\n     Hour:         h, H, Hour, Hours, ...\n\n     Minute:       m, M, Min, minute, Minutes, ...\n\n     Second:       s, S, sec, Secs, second, Seconds, ...\n\n     MilliSecond:  ms, Msec, mSecs, milliSecond, MilliSecond, ...\n\n Numbers with no unit are considered as microseconds.\n Specifying `accurate:` is equivalent to using `accurate_new`.\nSynonyms:\nbirl/duration.parse\nbirl/duration parse","url":"birl/duration.html#parse"},{"doc":"birl/duration","title":"birl/duration","content":"","url":"birl/duration.html"},{"doc":"birl/time","title":"Date","content":"pub type Date {\n  Date(day: Int, month: Int, year: Int)\n}\n\nDate(day: Int, month: Int, year: Int)\n\n\nSynonyms:\nbirl/time.Date\nbirl/time Date","url":"birl/time.html#Date"},{"doc":"birl/time","title":"DateTime","content":"pub opaque type DateTime\n\n\nSynonyms:\nbirl/time.DateTime\nbirl/time DateTime","url":"birl/time.html#DateTime"},{"doc":"birl/time","title":"Month","content":"pub type Month {\n  Jan\n  Feb\n  Mar\n  Apr\n  May\n  Jun\n  Jul\n  Aug\n  Sep\n  Oct\n  Nov\n  Dec\n}\n\nJan\n\n\nFeb\n\n\nMar\n\n\nApr\n\n\nMay\n\n\nJun\n\n\nJul\n\n\nAug\n\n\nSep\n\n\nOct\n\n\nNov\n\n\nDec\n\n\nSynonyms:\nbirl/time.Month\nbirl/time Month","url":"birl/time.html#Month"},{"doc":"birl/time","title":"Time","content":"pub type Time {\n  Time(hour: Int, minute: Int, second: Int, milli_second: Int)\n}\n\nTime(hour: Int, minute: Int, second: Int, milli_second: Int)\n\n\nSynonyms:\nbirl/time.Time\nbirl/time Time","url":"birl/time.html#Time"},{"doc":"birl/time","title":"Weekday","content":"pub type Weekday {\n  Mon\n  Tue\n  Wed\n  Thu\n  Fri\n  Sat\n  Sun\n}\n\nMon\n\n\nTue\n\n\nWed\n\n\nThu\n\n\nFri\n\n\nSat\n\n\nSun\n\n\nSynonyms:\nbirl/time.Weekday\nbirl/time Weekday","url":"birl/time.html#Weekday"},{"doc":"birl/time","title":"unix_epoch","content":"pub const unix_epoch: DateTime = DateTime(0, 0, option.None)\n starting point of unix timestamps\nSynonyms:\nbirl/time.unix_epoch\nbirl/time unix_epoch","url":"birl/time.html#unix_epoch"},{"doc":"birl/time","title":"add","content":"pub fn add(value: DateTime, duration: Duration) -&gt; DateTime\n\nSynonyms:\nbirl/time.add\nbirl/time add","url":"birl/time.html#add"},{"doc":"birl/time","title":"compare","content":"pub fn compare(a: DateTime, b: DateTime) -&gt; Order\n\nSynonyms:\nbirl/time.compare\nbirl/time compare","url":"birl/time.html#compare"},{"doc":"birl/time","title":"difference","content":"pub fn difference(a: DateTime, b: DateTime) -&gt; Duration\n\nSynonyms:\nbirl/time.difference\nbirl/time difference","url":"birl/time.html#difference"},{"doc":"birl/time","title":"from_erlang_local_datetime","content":"pub fn from_erlang_local_datetime(erlang_datetime: #(\n    #(Int, Int, Int),\n    #(Int, Int, Int),\n  )) -&gt; DateTime\n calculates the DateTime value from the erlang datetime using the local offset of the system\nSynonyms:\nbirl/time.from_erlang_local_datetime\nbirl/time from_erlang_local_datetime","url":"birl/time.html#from_erlang_local_datetime"},{"doc":"birl/time","title":"from_erlang_universal_datetime","content":"pub fn from_erlang_universal_datetime(erlang_datetime: #(\n    #(Int, Int, Int),\n    #(Int, Int, Int),\n  )) -&gt; DateTime\n calculates the DateTime value from the erlang datetime in UTC\nSynonyms:\nbirl/time.from_erlang_universal_datetime\nbirl/time from_erlang_universal_datetime","url":"birl/time.html#from_erlang_universal_datetime"},{"doc":"birl/time","title":"from_http","content":"pub fn from_http(value: String) -&gt; Result(DateTime, Nil)\n see [here](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Date)\nSynonyms:\nbirl/time.from_http\nbirl/time from_http","url":"birl/time.html#from_http"},{"doc":"birl/time","title":"from_iso8601","content":"pub fn from_iso8601(value: String) -&gt; Result(DateTime, Nil)\n\nSynonyms:\nbirl/time.from_iso8601\nbirl/time from_iso8601","url":"birl/time.html#from_iso8601"},{"doc":"birl/time","title":"from_unix","content":"pub fn from_unix(value: Int) -&gt; DateTime\n unix timestamps are the number of seconds that have elapsed since 00:00:00 UTC on January 1st, 1970\nSynonyms:\nbirl/time.from_unix\nbirl/time from_unix","url":"birl/time.html#from_unix"},{"doc":"birl/time","title":"get_date","content":"pub fn get_date(value: DateTime) -&gt; Date\n\nSynonyms:\nbirl/time.get_date\nbirl/time get_date","url":"birl/time.html#get_date"},{"doc":"birl/time","title":"get_offset","content":"pub fn get_offset(value: DateTime) -&gt; String\n\nSynonyms:\nbirl/time.get_offset\nbirl/time get_offset","url":"birl/time.html#get_offset"},{"doc":"birl/time","title":"get_time","content":"pub fn get_time(value: DateTime) -&gt; Time\n\nSynonyms:\nbirl/time.get_time\nbirl/time get_time","url":"birl/time.html#get_time"},{"doc":"birl/time","title":"legible_difference","content":"pub fn legible_difference(a: DateTime, b: DateTime) -&gt; String\n\nSynonyms:\nbirl/time.legible_difference\nbirl/time legible_difference","url":"birl/time.html#legible_difference"},{"doc":"birl/time","title":"monotonic_now","content":"pub fn monotonic_now() -&gt; Int\n\nSynonyms:\nbirl/time.monotonic_now\nbirl/time monotonic_now","url":"birl/time.html#monotonic_now"},{"doc":"birl/time","title":"month","content":"pub fn month(value: DateTime) -&gt; Month\n\nSynonyms:\nbirl/time.month\nbirl/time month","url":"birl/time.html#month"},{"doc":"birl/time","title":"now","content":"pub fn now() -&gt; DateTime\n use this to get the current time in the local timezone offset\nSynonyms:\nbirl/time.now\nbirl/time now","url":"birl/time.html#now"},{"doc":"birl/time","title":"now_with_offset","content":"pub fn now_with_offset(offset: String) -&gt; Result(DateTime, Nil)\n use this to get the current time with a given offset.\n\n Some examples of acceptable offsets:\n\n `&quot;+330&quot;, &quot;03:30&quot;, &quot;-8:00&quot;,&quot;-7&quot;, &quot;-0400&quot;, &quot;03&quot;`\nSynonyms:\nbirl/time.now_with_offset\nbirl/time now_with_offset","url":"birl/time.html#now_with_offset"},{"doc":"birl/time","title":"range","content":"pub fn range(from a: DateTime, to b: Option(DateTime), step s: Duration) -&gt; Iterator(\n  DateTime,\n)\n can be used to create a time range starting from time `a` with step `s`\n\n if `b` is `option.None` the range will be infinite\nSynonyms:\nbirl/time.range\nbirl/time range","url":"birl/time.html#range"},{"doc":"birl/time","title":"set_date","content":"pub fn set_date(value: DateTime, date: Date) -&gt; DateTime\n\nSynonyms:\nbirl/time.set_date\nbirl/time set_date","url":"birl/time.html#set_date"},{"doc":"birl/time","title":"set_offset","content":"pub fn set_offset(value: DateTime, new_offset: String) -&gt; Result(\n  DateTime,\n  Nil,\n)\n use this tp change the offset of a given time value.\n\n Some examples of acceptable offsets:\n\n `&quot;+330&quot;, &quot;03:30&quot;, &quot;-8:00&quot;,&quot;-7&quot;, &quot;-0400&quot;, &quot;03&quot;, &quot;Z&quot;`\nSynonyms:\nbirl/time.set_offset\nbirl/time set_offset","url":"birl/time.html#set_offset"},{"doc":"birl/time","title":"set_time","content":"pub fn set_time(value: DateTime, time: Time) -&gt; DateTime\n\nSynonyms:\nbirl/time.set_time\nbirl/time set_time","url":"birl/time.html#set_time"},{"doc":"birl/time","title":"short_string_month","content":"pub fn short_string_month(value: DateTime) -&gt; String\n\nSynonyms:\nbirl/time.short_string_month\nbirl/time short_string_month","url":"birl/time.html#short_string_month"},{"doc":"birl/time","title":"short_string_weekday","content":"pub fn short_string_weekday(value: DateTime) -&gt; String\n\nSynonyms:\nbirl/time.short_string_weekday\nbirl/time short_string_weekday","url":"birl/time.html#short_string_weekday"},{"doc":"birl/time","title":"string_month","content":"pub fn string_month(value: DateTime) -&gt; String\n\nSynonyms:\nbirl/time.string_month\nbirl/time string_month","url":"birl/time.html#string_month"},{"doc":"birl/time","title":"string_weekday","content":"pub fn string_weekday(value: DateTime) -&gt; String\n\nSynonyms:\nbirl/time.string_weekday\nbirl/time string_weekday","url":"birl/time.html#string_weekday"},{"doc":"birl/time","title":"subtract","content":"pub fn subtract(value: DateTime, duration: Duration) -&gt; DateTime\n\nSynonyms:\nbirl/time.subtract\nbirl/time subtract","url":"birl/time.html#subtract"},{"doc":"birl/time","title":"to_erlang_datetime","content":"pub fn to_erlang_datetime(value: DateTime) -&gt; #(\n  #(Int, Int, Int),\n  #(Int, Int, Int),\n)\n calculates erlang datetime using the offset in the DateTime value\nSynonyms:\nbirl/time.to_erlang_datetime\nbirl/time to_erlang_datetime","url":"birl/time.html#to_erlang_datetime"},{"doc":"birl/time","title":"to_erlang_universal_datetime","content":"pub fn to_erlang_universal_datetime(value: DateTime) -&gt; #(\n  #(Int, Int, Int),\n  #(Int, Int, Int),\n)\n calculates the universal erlang datetime regardless of the offset in the DateTime value\nSynonyms:\nbirl/time.to_erlang_universal_datetime\nbirl/time to_erlang_universal_datetime","url":"birl/time.html#to_erlang_universal_datetime"},{"doc":"birl/time","title":"to_http","content":"pub fn to_http(value: DateTime) -&gt; String\n see [here](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Date)\nSynonyms:\nbirl/time.to_http\nbirl/time to_http","url":"birl/time.html#to_http"},{"doc":"birl/time","title":"to_iso8601","content":"pub fn to_iso8601(value: DateTime) -&gt; String\n\nSynonyms:\nbirl/time.to_iso8601\nbirl/time to_iso8601","url":"birl/time.html#to_iso8601"},{"doc":"birl/time","title":"to_unix","content":"pub fn to_unix(value: DateTime) -&gt; Int\n unix timestamps are the number of seconds that have elapsed since 00:00:00 UTC on January 1st, 1970\nSynonyms:\nbirl/time.to_unix\nbirl/time to_unix","url":"birl/time.html#to_unix"},{"doc":"birl/time","title":"utc_now","content":"pub fn utc_now() -&gt; DateTime\n use this to get the current time in utc\nSynonyms:\nbirl/time.utc_now\nbirl/time utc_now","url":"birl/time.html#utc_now"},{"doc":"birl/time","title":"weekday","content":"pub fn weekday(value: DateTime) -&gt; Weekday\n\nSynonyms:\nbirl/time.weekday\nbirl/time weekday","url":"birl/time.html#weekday"},{"doc":"birl/time","title":"birl/time","content":"","url":"birl/time.html"}]);